OGRE: Ogre::Light Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::Light Class Reference
[Scene]

Representation of a dynamic light source in the scene. More...

`#include <OgreLight.h>`

Inheritance diagram for Ogre::Light:
[legend]

List of all members.

## Public Types
enum | LightTypes { LT_POINT = 0, LT_DIRECTIONAL = 1, LT_SPOTLIGHT = 2 }
| Defines the type of light. More...
typedef vector < ShadowRenderable * >::type | ShadowRenderableList
typedef VectorIterator < ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
void | _calcTempSquareDist (const Vector3 &worldPos)
| internal method for calculating current squared distance from some world position
| Light ()
| Default constructor (for Python mainly).
| Light (const String &name)
| Normal constructor.
| ~Light ()
| Standard destructor.
void | setType (LightTypes type)
| Sets the type of light - see LightTypes for more info.
LightTypes | getType (void) const
| Returns the light type.
void | setDiffuseColour (Real red, Real green, Real blue)
| Sets the colour of the diffuse light given off by this source.
void | setDiffuseColour (const ColourValue &colour)
| Sets the colour of the diffuse light given off by this source.
const ColourValue & | getDiffuseColour (void) const
| Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).
void | setSpecularColour (Real red, Real green, Real blue)
| Sets the colour of the specular light given off by this source.
void | setSpecularColour (const ColourValue &colour)
| Sets the colour of the specular light given off by this source.
const ColourValue & | getSpecularColour (void) const
| Returns the colour of specular light given off by this light source.
void | setAttenuation (Real range, Real constant, Real linear, Real quadratic)
| Sets the attenuation parameters of the light source i.e.
Real | getAttenuationRange (void) const
| Returns the absolute upper range of the light.
Real | getAttenuationConstant (void) const
| Returns the constant factor in the attenuation formula.
Real | getAttenuationLinear (void) const
| Returns the linear factor in the attenuation formula.
Real | getAttenuationQuadric (void) const
| Returns the quadric factor in the attenuation formula.
void | setPosition (Real x, Real y, Real z)
| Sets the position of the light.
void | setPosition (const Vector3 &vec)
| Sets the position of the light.
const Vector3 & | getPosition (void) const
| Returns the position of the light.
void | setDirection (Real x, Real y, Real z)
| Sets the direction in which a light points.
void | setDirection (const Vector3 &vec)
| Sets the direction in which a light points.
const Vector3 & | getDirection (void) const
| Returns the light's direction.
void | setSpotlightRange (const Radian &innerAngle, const Radian &outerAngle, Real falloff=1.0)
| Sets the range of a spotlight, i.e.
const Radian & | getSpotlightInnerAngle (void) const
| Returns the angle covered by the spotlights inner cone.
const Radian & | getSpotlightOuterAngle (void) const
| Returns the angle covered by the spotlights outer cone.
Real | getSpotlightFalloff (void) const
| Returns the falloff between the inner and outer cones of the spotlight.
void | setSpotlightInnerAngle (const Radian &val)
| Sets the angle covered by the spotlights inner cone.
void | setSpotlightOuterAngle (const Radian &val)
| Sets the angle covered by the spotlights outer cone.
void | setSpotlightFalloff (Real val)
| Sets the falloff between the inner and outer cones of the spotlight.
void | setPowerScale (Real power)
| Set a scaling factor to indicate the relative power of a light.
Real | getPowerScale (void) const
| Set the scaling factor which indicates the relative power of a light.
void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Overridden from MovableObject.
void | _notifyMoved (void)
| Overridden from MovableObject.
const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject.
void | _updateRenderQueue (RenderQueue *queue)
| Overridden from MovableObject.
const String & | getMovableType (void) const
| Overridden from MovableObject.
const Vector3 & | getDerivedPosition (bool cameraRelativeIfSet=false) const
| Retrieves the position of the light including any transform from nodes it is attached to.
const Vector3 & | getDerivedDirection (void) const
| Retrieves the direction of the light including any transform from nodes it is attached to.
void | setVisible (bool visible)
| Overridden from MovableObject.
Real | getBoundingRadius (void) const
| Overridden from MovableObject.
Vector4 | getAs4DVector (bool cameraRelativeIfSet=false) const
| Gets the details of this light as a 4D vector.
virtual const PlaneBoundedVolume & | _getNearClipVolume (const Camera *const cam) const
| Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.
virtual const PlaneBoundedVolumeList & | _getFrustumClipVolumes (const Camera *const cam) const
| Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.
uint32 | getTypeFlags (void) const
| Override to return specific type flag.
AnimableValuePtr | createAnimableValue (const String &valueName)
void | setCustomShadowCameraSetup (const ShadowCameraSetupPtr &customShadowSetup)
| Set this light to use a custom shadow camera when rendering texture shadows.
void | resetCustomShadowCameraSetup (void)
| Reset the shadow camera setup to the default.
const ShadowCameraSetupPtr & | getCustomShadowCameraSetup (void) const
| return a pointer to the custom shadow camera setup (null means use SceneManager global version).
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
size_t | _getIndexInFrame () const
| Gets the index at which this light is in the current render.
void | _notifyIndexInFrame (size_t i)
void | setShadowFarDistance (Real distance)
| Sets the maximum distance away from the camera that shadows by this light will be visible.
void | resetShadowFarDistance (void)
| Tells the light to use the shadow far distance of the SceneManager.
Real | getShadowFarDistance (void) const
| Gets the maximum distance away from the camera that shadows by this light will be visible.
Real | getShadowFarDistanceSquared (void) const
void | setShadowNearClipDistance (Real nearClip)
| Set the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Real | getShadowNearClipDistance () const
| Get the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Real | _deriveShadowNearClipDistance (const Camera *maincam) const
| Derive a shadow camera near distance from either the light, or from the main camera if the light doesn't have its own setting.
void | setShadowFarClipDistance (Real farClip)
| Set the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Real | getShadowFarClipDistance () const
| Get the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Real | _deriveShadowFarClipDistance (const Camera *maincam) const
| Derive a shadow camera far distance from either the light, or from the main camera if the light doesn't have its own setting.
void | _setCameraRelative (Camera *cam)
| Set the camera which this light should be relative to, for camera-relative rendering.
void | setCustomParameter (uint16 index, const Vector4 &value)
| Sets a custom parameter for this Light, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (uint16 index) const
| Gets the custom value associated with this Light at the given index.
virtual void | _updateCustomGpuParameter (uint16 paramIndex, const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Light knows.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const =0
| Get the world bounding box of the caster.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserAny (const Any &anything)
virtual const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
virtual uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
virtual void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
virtual LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual EdgeData * | getEdgeList (void)=0
| Returns details of the edges which might be used to determine a silhouette.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual bool | hasEdgeList (void)=0
| Returns whether the object has a valid edge list.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)=0
| Gets an iterator over the renderables required to render the shadow volume.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
virtual const AxisAlignedBox & | getLightCapBounds (void) const =0
| Gets the world space bounding box of the light cap.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
virtual const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const =0
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
virtual bool | getCastShadows (void) const =0
| Returns whether or not this object currently casts a shadow.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual Real | getPointExtrusionDistance (const Light *l) const =0
| Get the distance to extrude for a point/spot light.
virtual void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
virtual bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Public Attributes
Real | tempSquareDist
| Temp tag used for sorting.
## Protected Types
typedef map< uint16, Vector4 > ::type | CustomParameterMap
typedef map< String, StringVector >::type | AnimableDictionaryMap
## Protected Member Functions
virtual void | update (void) const
| internal method for synchronising with parent node (if any)
const String & | getAnimableDictionaryName (void) const
void | initialiseAnimableDictionary (StringVector &vec) const
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper method for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
LightTypes | mLightType
Vector3 | mPosition
ColourValue | mDiffuse
ColourValue | mSpecular
Vector3 | mDirection
Radian | mSpotOuter
Radian | mSpotInner
Real | mSpotFalloff
Real | mRange
Real | mAttenuationConst
Real | mAttenuationLinear
Real | mAttenuationQuad
Real | mPowerScale
size_t | mIndexInFrame
bool | mOwnShadowFarDist
Real | mShadowFarDist
Real | mShadowFarDistSquared
Real | mShadowNearClipDist
Real | mShadowFarClipDist
Vector3 | mDerivedPosition
Vector3 | mDerivedDirection
Vector3 | mDerivedCamRelativePosition
bool | mDerivedCamRelativeDirty
Camera * | mCameraToBeRelativeTo
PlaneBoundedVolume | mNearClipVolume
PlaneBoundedVolumeList | mFrustumClipVolumes
bool | mDerivedTransformDirty
| Is the derived transform dirty?
ShadowCameraSetupPtr | mCustomShadowCameraSetup
| Pointer to a custom shadow camera setup.
CustomParameterMap | mCustomParameters
| Stores the custom parameters for the light.
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
bool | mDebugDisplay
| Is debug display enabled?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
UserObjectBindings | mUserObjectBindings
| User objects binding.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
ushort | mRenderQueuePriority
| The render queue group to use when rendering this object.
bool | mRenderQueuePrioritySet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
uint32 | mLightMask
| the light mask defined for this movable. This will be taken into consideration when deciding which light should affect this movable
## Static Protected Attributes
static String | msMovableType
| Shared class-level name for Movable type.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.

## Detailed Description

Representation of a dynamic light source in the scene.

Remarks:
  Lights are added to the scene like any other object. They contain various parameters like type, position, attenuation (how light intensity fades with distance), colour etc.

  The defaults when a light is created is pure white diffuse light, with no attenuation (does not decrease with distance) and a range of 1000 world units.

  Lights are created by using the SceneManager::createLight method. They can subsequently be added to a SceneNode if required to allow them to move relative to a node in the scene. A light attached to a SceneNode is assumed to have a base position of (0,0,0) and a direction of (0,0,1) before modification by the SceneNode's own orientation. If not attached to a SceneNode, the light's position and direction is as set using setPosition and setDirection.

  Remember also that dynamic lights rely on modifying the colour of vertices based on the position of the light compared to an object's vertex normals. Dynamic lighting will only look good if the object being lit has a fair level of tessellation and the normals are properly set. This is particularly true for the spotlight which will only look right on highly tessellated models. In the future OGRE may be extended for certain scene types so an alternative to the standard dynamic lighting may be used, such as dynamic lightmaps.

Definition at line 72 of file OgreLight.h.

## Member Typedef Documentation

typedef map<String, StringVector>::type Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

Definition at line 240 of file OgreAnimable.h.

typedef map<uint16, Vector4>::type Ogre::Light::CustomParameterMap`[protected]`

Definition at line 560 of file OgreLight.h.

typedef vector<ShadowRenderable*>::type Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

Definition at line 128 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

Definition at line 129 of file OgreShadowCaster.h.

## Member Enumeration Documentation

enum Ogre::Light::LightTypes

Defines the type of light.

Enumerator:

  LT_POINT | Point light sources give off light equally in all directions, so require only position not direction.
  LT_DIRECTIONAL | Directional lights simulate parallel light beams from a distant source, hence have direction but no position.
  LT_SPOTLIGHT | Spotlights simulate a cone of light from a source so require position and direction, plus extra values for falloff.

Definition at line 81 of file OgreLight.h.

## Constructor & Destructor Documentation

Ogre::Light::Light | ( |  | ) |

Default constructor (for Python mainly).

Ogre::Light::Light | ( | const String & | name | ) |

Normal constructor.

Should not be called directly, but rather the SceneManager::createLight method should be used.

Ogre::Light::~Light | ( |  | ) |

Standard destructor.

## Member Function Documentation

void Ogre::Light::_calcTempSquareDist | ( | const Vector3 & | worldPos | ) |

internal method for calculating current squared distance from some world position

Real Ogre::Light::_deriveShadowFarClipDistance | ( | const Camera * | maincam | ) | const

Derive a shadow camera far distance from either the light, or from the main camera if the light doesn't have its own setting.

Real Ogre::Light::_deriveShadowNearClipDistance | ( | const Camera * | maincam | ) | const

Derive a shadow camera near distance from either the light, or from the main camera if the light doesn't have its own setting.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

Get an updateable reference to animable value list.

Definition at line 266 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

Get the creator of this object, if any (internal use only).

Definition at line 183 of file OgreMovableObject.h.

virtual const PlaneBoundedVolumeList& Ogre::Light::_getFrustumClipVolumes | ( | const Camera *const | cam | ) | const`[virtual]`

Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.

Remarks:
  Each of the volumes is a pyramid for a point/spot light and a cuboid for a directional light.

size_t Ogre::Light::_getIndexInFrame | ( |  | ) | const

Gets the index at which this light is in the current render.

Remarks:
  Lights will be present in the in a list for every renderable, detected and sorted appropriately, and sometimes it's useful to know what position in that list a given light occupies. This can vary from frame to frame (and object to object) so you should not use this value unless you're sure the context is correct.

Definition at line 391 of file OgreLight.h.

virtual LightList* Ogre::MovableObject::_getLightList | ( |  | ) | `[virtual, inherited]`

Returns a pointer to the current list of lights for this object.

Remarks:
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

Definition at line 472 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

Get the manager of this object, if any (internal use only).

Definition at line 187 of file OgreMovableObject.h.

virtual const PlaneBoundedVolume& Ogre::Light::_getNearClipVolume | ( | const Camera *const | cam | ) | const`[virtual]`

Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.

Remarks:
  This volume is a pyramid for a point/spot light and a cuboid for a directional light. It can used to detect whether an object could be casting a shadow on the viewport. Note that the reference returned is to a shared volume which will be reused across calls to this method.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

return the full transformation of the parent sceneNode or the attachingPoint node

void Ogre::Light::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual]`

Overridden from MovableObject.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

Notify the object of it's creator (internal use only).

Definition at line 181 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

Internal method to notify the object of the camera to be used for the next rendering operation.

Remarks:
  Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, Ogre::MovablePlane, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

void Ogre::Light::_notifyIndexInFrame | ( | size_t | i | ) |

Definition at line 392 of file OgreLight.h.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

Notify the object of it's manager (internal use only).

Definition at line 185 of file OgreMovableObject.h.

void Ogre::Light::_notifyMoved | ( | void |  | ) | `[virtual]`

Overridden from MovableObject.

Reimplemented from Ogre::MovableObject.

void Ogre::Light::_setCameraRelative | ( | Camera * | cam | ) |

Set the camera which this light should be relative to, for camera-relative rendering.

virtual void Ogre::Light::_updateCustomGpuParameter | ( | uint16 | paramIndex,
|  | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual]`

Update a custom GpuProgramParameters constant which is derived from information only this Light knows.

Remarks:
  This method allows a Light to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_LIGHT_CUSTOM, and to allow there to be more than one of these per Light, the 'data' field on the auto parameter will identify which parameter is being updated and on which light. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | paramIndex | The index of the constant being updated
  | constantEntry | The auto constant entry from the program parameters
  | params | The parameters object which this method should call to set the updated parameters.

void Ogre::Light::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 377 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 405 of file OgreMovableObject.h.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

Internal method for creating a dictionary of animable value names for the class, if it does not already exist.

Definition at line 253 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Definition at line 319 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

AnimableValuePtr Ogre::Light::createAnimableValue | ( | const String & | valueName | ) |

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

virtual void Ogre::MovableObject::detachFromParent | ( | void |  | ) | `[virtual, inherited]`

Detaches an object from a parent SceneNode or TagPoint, if attached.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags |
| ) |  |  | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

const String& Ogre::Light::getAnimableDictionaryName | ( | void |  | ) | const`[protected]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Definition at line 248 of file OgreAnimable.h.

References Ogre::StringUtil::BLANK.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

Gets a list of animable value names for this object.

Definition at line 294 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

Vector4 Ogre::Light::getAs4DVector | ( | bool | cameraRelativeIfSet = `false` | ) | const

Gets the details of this light as a 4D vector.

Remarks:
  Getting details of a light as a 4D vector can be useful for doing general calculations between different light types; for example the vector can represent both position lights (w=1.0f) and directional lights (w=0.0f) and be used in the same calculations.

Parameters:

  | cameraRelativeIfSet | If set to true, returns data in camera-relative units if that's been set up (render use)

Real Ogre::Light::getAttenuationConstant | ( | void |  | ) | const

Returns the constant factor in the attenuation formula.

Real Ogre::Light::getAttenuationLinear | ( | void |  | ) | const

Returns the linear factor in the attenuation formula.

Real Ogre::Light::getAttenuationQuadric | ( | void |  | ) | const

Returns the quadric factor in the attenuation formula.

Real Ogre::Light::getAttenuationRange | ( | void |  | ) | const

Returns the absolute upper range of the light.

const AxisAlignedBox& Ogre::Light::getBoundingBox | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

Real Ogre::Light::getBoundingRadius | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

Definition at line 325 of file OgreLight.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[inherited]`

Returns whether shadow casting is enabled for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 502 of file OgreMovableObject.h.

virtual bool Ogre::ShadowCaster::getCastShadows | ( | void |  | ) | const`[pure virtual, inherited]`

Returns whether or not this object currently casts a shadow.

const Vector4& Ogre::Light::getCustomParameter | ( | uint16 | index | ) | const

Gets the custom value associated with this Light at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

const ShadowCameraSetupPtr& Ogre::Light::getCustomShadowCameraSetup | ( | void |  | ) | const

return a pointer to the custom shadow camera setup (null means use SceneManager global version).

virtual const AxisAlignedBox& Ogre::ShadowCaster::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[pure virtual, inherited]`

Gets the world space bounding box of the dark cap, as extruded using the light provided.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[inherited]`

Overridden member from ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

Get the default query flags for all future MovableObject instances.

Definition at line 392 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

Get the default visibility flags for all future MovableObject instances.

Definition at line 420 of file OgreMovableObject.h.

const Vector3& Ogre::Light::getDerivedDirection | ( | void |  | ) | const

Retrieves the direction of the light including any transform from nodes it is attached to.

const Vector3& Ogre::Light::getDerivedPosition | ( | bool | cameraRelativeIfSet = `false` | ) | const

Retrieves the position of the light including any transform from nodes it is attached to.

Parameters:

  | cameraRelativeIfSet | If set to true, returns data in camera-relative units if that's been set up (render use)

const ColourValue& Ogre::Light::getDiffuseColour | ( | void |  | ) | const

Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).

const Vector3& Ogre::Light::getDirection | ( | void |  | ) | const

Returns the light's direction.

Remarks:
  Applicable only to the spotlight and directional light types.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 475 of file OgreMovableObject.h.

virtual EdgeData* Ogre::ShadowCaster::getEdgeList | ( | void |  | ) | `[pure virtual, inherited]`

Returns details of the edges which might be used to determine a silhouette.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light |
| ) |  |  | const`[protected, inherited]`

Helper method for calculating extrusion distance.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[inherited]`

Overridden member from ShadowCaster.

virtual const AxisAlignedBox& Ogre::ShadowCaster::getLightCapBounds | ( | void |  | ) | const`[pure virtual, inherited]`

Gets the world space bounding box of the light cap.

virtual uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const`[virtual, inherited]`

Get a bitwise mask which will filter the lights affecting this object.

Remarks:
  By default, this mask is fully set meaning all lights will affect this object

Definition at line 457 of file OgreMovableObject.h.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

Gets the current listener for this object.

Definition at line 431 of file OgreMovableObject.h.

const String& Ogre::Light::getMovableType | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

Returns the name of this object.

Definition at line 190 of file OgreMovableObject.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

virtual Real Ogre::ShadowCaster::getPointExtrusionDistance | ( | const Light * | l | ) | const`[pure virtual, inherited]`

Get the distance to extrude for a point/spot light.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[inherited]`

Get the distance to extrude for a point/spot light.

const Vector3& Ogre::Light::getPosition | ( | void |  | ) | const

Returns the position of the light.

Note:
  Applicable to point lights and spotlights only.

Real Ogre::Light::getPowerScale | ( | void |  | ) | const

Set the scaling factor which indicates the relative power of a light.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the query flags relevant for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 384 of file OgreMovableObject.h.

bool Ogre::MovableObject::getReceivesShadows | ( |  | ) | `[inherited]`

Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

Gets the distance at which batches are no longer rendered.

Definition at line 301 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

Gets the queue group for this entity, see setRenderQueueGroup for full details.

Real Ogre::Light::getShadowFarClipDistance | ( |  | ) | const

Get the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.

Remarks:
  May be zero if the light doesn't have it's own far distance set; use _deriveShadowfarDistance for a version guaranteed to give a result.

Definition at line 451 of file OgreLight.h.

Real Ogre::Light::getShadowFarDistance | ( | void |  | ) | const

Gets the maximum distance away from the camera that shadows by this light will be visible.

Real Ogre::Light::getShadowFarDistanceSquared | ( | void |  | ) | const

Real Ogre::Light::getShadowNearClipDistance | ( |  | ) | const

Get the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.

Remarks:
  May be zero if the light doesn't have it's own near distance set; use _deriveShadowNearDistance for a version guaranteed to give a result.

Definition at line 430 of file OgreLight.h.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0` |
| ) |  |  | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

virtual ShadowRenderableListIterator Ogre::ShadowCaster::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDistance,
|  | unsigned long | flags = `0` |
| ) |  |  | `[pure virtual, inherited]`

Gets an iterator over the renderables required to render the shadow volume.

Remarks:
  Shadowable geometry should ideally be designed such that there is only one ShadowRenderable required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required.

Parameters:

  | shadowTechnique | The technique being used to generate the shadow
  | light | The light to generate the shadow from
  | indexBuffer | The index buffer to build the renderables into, the current contents are assumed to be disposable.
  | extrudeVertices | If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed).
  | extrusionDistance | The distance to extrude the shadow volume
  | flags | Technique-specific flags, see ShadowRenderableFlags

const ColourValue& Ogre::Light::getSpecularColour | ( | void |  | ) | const

Returns the colour of specular light given off by this light source.

Real Ogre::Light::getSpotlightFalloff | ( | void |  | ) | const

Returns the falloff between the inner and outer cones of the spotlight.

const Radian& Ogre::Light::getSpotlightInnerAngle | ( | void |  | ) | const

Returns the angle covered by the spotlights inner cone.

const Radian& Ogre::Light::getSpotlightOuterAngle | ( | void |  | ) | const

Returns the angle covered by the spotlights outer cone.

LightTypes Ogre::Light::getType | ( | void |  | ) | const

Returns the light type.

uint32 Ogre::Light::getTypeFlags | ( | void |  | ) | const`[virtual]`

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

Retrieves the custom user value associated with this object.

Definition at line 315 of file OgreMovableObject.h.

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | `[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 321 of file OgreMovableObject.h.

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const`[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 327 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the visibility flags relevant for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 412 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the axis-aligned bounding box for this object in world coordinates.

virtual const AxisAlignedBox& Ogre::ShadowCaster::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[pure virtual, inherited]`

Get the world bounding box of the caster.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the worldspace bounding sphere for this object.

virtual bool Ogre::ShadowCaster::hasEdgeList | ( | void |  | ) | `[pure virtual, inherited]`

Returns whether the object has a valid edge list.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 477 of file OgreMovableObject.h.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

Definition at line 286 of file OgreAnimable.h.

void Ogre::Light::initialiseAnimableDictionary | ( | StringVector & | vec | ) | const`[protected]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const`[virtual, inherited]`

Gets whether debug display of this object is enabled.

Definition at line 546 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::MovableObject::isParentTagPoint | ( |  | ) | const`[virtual, inherited]`

Gets whether the parent node is a TagPoint (or a SceneNode).

Definition at line 213 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, Ogre::StaticGeometry::Region, and Ogre::TerrainQuadTreeNode::Movable.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 381 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 409 of file OgreMovableObject.h.

void Ogre::Light::resetCustomShadowCameraSetup | ( | void |  | ) |

Reset the shadow camera setup to the default.

See also:
  ShadowCameraSetup

void Ogre::Light::resetShadowFarDistance | ( | void |  | ) |

Tells the light to use the shadow far distance of the SceneManager.

void Ogre::Light::setAttenuation | ( | Real | range,
|  | Real | constant,
|  | Real | linear,
|  | Real | quadratic |
| ) |  |  |

Sets the attenuation parameters of the light source i.e.

how it diminishes with distance.

Remarks:
  Lights normally get fainter the further they are away. Also, each light is given a maximum range beyond which it cannot affect any objects.

  Light attenuation is not applicable to directional lights since they have an infinite range and constant intensity.

  This follows a standard attenuation approach - see any good 3D text for the details of what they mean since i don't have room here!

Parameters:

  | range | The absolute upper range of the light in world units
  | constant | The constant factor in the attenuation formula: 1.0 means never attenuate, 0.0 is complete attenuation
  | linear | The linear factor in the attenuation formula: 1 means attenuate evenly over the distance
  | quadratic | The quadratic factor in the attenuation formula: adds a curvature to the attenuation formula.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 500 of file OgreMovableObject.h.

void Ogre::Light::setCustomParameter | ( | uint16 | index,
|  | const Vector4 & | value |
| ) |  |  |

Sets a custom parameter for this Light, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Light. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_LIGHT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_LIGHT_CUSTOM entry, if that is used.
  | value | The value to associate.

void Ogre::Light::setCustomShadowCameraSetup | ( | const ShadowCameraSetupPtr & | customShadowSetup | ) |

Set this light to use a custom shadow camera when rendering texture shadows.

Remarks:
  This changes the shadow camera setup for just this light, you can set the shadow camera setup globally using SceneManager::setShadowCameraSetup

See also:
  ShadowCameraSetup

virtual void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) | `[virtual, inherited]`

Sets whether or not the debug display of this object is enabled.

Remarks:
  Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

Definition at line 544 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default query flags for all future MovableObject instances.

Definition at line 388 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default visibility flags for all future MovableObject instances.

Definition at line 416 of file OgreMovableObject.h.

void Ogre::Light::setDiffuseColour | ( | const ColourValue & | colour | ) |

Sets the colour of the diffuse light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Diffuse light simulates the typical light emanating from light sources and affects the base colour of objects together with ambient light.

void Ogre::Light::setDiffuseColour | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the colour of the diffuse light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Diffuse light simulates the typical light emanating from light sources and affects the base colour of objects together with ambient light.

void Ogre::Light::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z |
| ) |  |  |

Sets the direction in which a light points.

Remarks:
  Applicable only to the spotlight and directional light types.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setDirection | ( | const Vector3 & | vec | ) |

Sets the direction in which a light points.

Remarks:
  Applicable only to the spotlight and directional light types.

Note:
  This will be overridden if the light is attached to a SceneNode.

virtual void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) | `[virtual, inherited]`

Set a bitwise mask which will filter the lights affecting this object.

Remarks:
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 427 of file OgreMovableObject.h.

void Ogre::Light::setPosition | ( | const Vector3 & | vec | ) |

Sets the position of the light.

Remarks:
  Applicable to point lights and spotlights only.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z |
| ) |  |  |

Sets the position of the light.

Remarks:
  Applicable to point lights and spotlights only.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setPowerScale | ( | Real | power | ) |

Set a scaling factor to indicate the relative power of a light.

Remarks:
  This factor is only useful in High Dynamic Range (HDR) rendering. You can bind it to a shader variable to take it into account,

See also:
  GpuProgramParameters

Parameters:

  | power | The power rating of this light, default is 1.0.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 373 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 295 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

Reimplemented in Ogre::ParticleSystem.

virtual void Ogre::MovableObject::setRenderQueueGroupAndPriority | ( | uint8 | queueID,
|  | ushort | priority |
| ) |  |  | `[virtual, inherited]`

Sets the render queue group and group priority this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. Within a single render group there another type of grouping called priority which allows further control. If you do not call this method, all Entity objects default to the default queue and priority (RenderQueue::getDefaultQueueGroup, RenderQueue::getDefaultRenderablePriority), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.
  | priority | The priority within a group to use.

void Ogre::Light::setShadowFarClipDistance | ( | Real | farClip | ) |

Set the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.

Remarks:
  This is different from the 'shadow far distance', which is always measured from the main camera. This distance is the far clip plane of the light camera.

Parameters:

  | far | The distance, or -1 to use the main camera setting

Definition at line 444 of file OgreLight.h.

void Ogre::Light::setShadowFarDistance | ( | Real | distance | ) |

Sets the maximum distance away from the camera that shadows by this light will be visible.

Remarks:
  Shadow techniques can be expensive, therefore it is a good idea to limit them to being rendered close to the camera if possible, and to skip the expense of rendering shadows for distance objects. This method allows you to set the distance at which shadows will no longer be rendered.

Note:
  Each shadow technique can interpret this subtely differently. For example, one technique may use this to eliminate casters, another might use it to attenuate the shadows themselves. You should tweak this value to suit your chosen shadow technique and scene setup.

void Ogre::Light::setShadowNearClipDistance | ( | Real | nearClip | ) |

Set the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.

Parameters:

  | near | The distance, or -1 to use the main camera setting

Definition at line 423 of file OgreLight.h.

void Ogre::Light::setSpecularColour | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the colour of the specular light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Specular light affects the appearance of shiny highlights on objects, and is also dependent on the 'shininess' Material value.

void Ogre::Light::setSpecularColour | ( | const ColourValue & | colour | ) |

Sets the colour of the specular light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Specular light affects the appearance of shiny highlights on objects, and is also dependent on the 'shininess' Material value.

void Ogre::Light::setSpotlightFalloff | ( | Real | val | ) |

Sets the falloff between the inner and outer cones of the spotlight.

void Ogre::Light::setSpotlightInnerAngle | ( | const Radian & | val | ) |

Sets the angle covered by the spotlights inner cone.

void Ogre::Light::setSpotlightOuterAngle | ( | const Radian & | val | ) |

Sets the angle covered by the spotlights outer cone.

void Ogre::Light::setSpotlightRange | ( | const Radian & | innerAngle,
|  | const Radian & | outerAngle,
|  | Real | falloff = `1.0` |
| ) |  |  |

Sets the range of a spotlight, i.e.

the angle of the inner and outer cones and the rate of falloff between them.

Parameters:

  | innerAngle | Angle covered by the bright inner cone The inner cone applicable only to Direct3D, it'll always treat as zero in OpenGL.
  | outerAngle | Angle covered by the outer cone
  | falloff | The rate of falloff between the inner and outer cones. 1.0 means a linear falloff, less means slower falloff, higher means faster falloff.

void Ogre::Light::setType | ( | LightTypes | type | ) |

Sets the type of light - see LightTypes for more info.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Definition at line 310 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 401 of file OgreMovableObject.h.

void Ogre::Light::setVisible | ( | bool | visible | ) | `[virtual]`

Overridden from MovableObject.

Remarks:
  Although lights themselves are not 'visible', setting a light to invisible means it no longer affects the scene.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::Light::update | ( | void |  | ) | const`[protected, virtual]`

internal method for synchronising with parent node (if any)

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos |
| ) |  |  | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

void Ogre::Light::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## Member Data Documentation

Real Ogre::Light::mAttenuationConst`[protected]`

Definition at line 529 of file OgreLight.h.

Real Ogre::Light::mAttenuationLinear`[protected]`

Definition at line 530 of file OgreLight.h.

Real Ogre::Light::mAttenuationQuad`[protected]`

Definition at line 531 of file OgreLight.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

Hidden because of distance?

Definition at line 125 of file OgreMovableObject.h.

Camera* Ogre::Light::mCameraToBeRelativeTo`[protected]`

Definition at line 547 of file OgreLight.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

Does this object cast shadows?

Definition at line 147 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

Creator of this object (if created by a factory).

Definition at line 111 of file OgreMovableObject.h.

CustomParameterMap Ogre::Light::mCustomParameters`[protected]`

Stores the custom parameters for the light.

Definition at line 562 of file OgreLight.h.

ShadowCameraSetupPtr Ogre::Light::mCustomShadowCameraSetup`[mutable, protected]`

Pointer to a custom shadow camera setup.

Definition at line 558 of file OgreLight.h.

bool Ogre::MovableObject::mDebugDisplay`[protected, inherited]`

Is debug display enabled?

Definition at line 120 of file OgreMovableObject.h.

bool Ogre::Light::mDerivedCamRelativeDirty`[mutable, protected]`

Definition at line 546 of file OgreLight.h.

Vector3 Ogre::Light::mDerivedCamRelativePosition`[mutable, protected]`

Definition at line 545 of file OgreLight.h.

Vector3 Ogre::Light::mDerivedDirection`[mutable, protected]`

Definition at line 543 of file OgreLight.h.

Vector3 Ogre::Light::mDerivedPosition`[mutable, protected]`

Definition at line 542 of file OgreLight.h.

bool Ogre::Light::mDerivedTransformDirty`[mutable, protected]`

Is the derived transform dirty?

Definition at line 555 of file OgreLight.h.

ColourValue Ogre::Light::mDiffuse`[protected]`

Definition at line 520 of file OgreLight.h.

Vector3 Ogre::Light::mDirection`[protected]`

Definition at line 523 of file OgreLight.h.

PlaneBoundedVolumeList Ogre::Light::mFrustumClipVolumes`[mutable, protected]`

Definition at line 553 of file OgreLight.h.

size_t Ogre::Light::mIndexInFrame`[protected]`

Definition at line 533 of file OgreLight.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

List of lights for this object.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 155 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

The last frame that this light list was updated in.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 157 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mLightMask`[protected, inherited]`

the light mask defined for this movable. This will be taken into consideration when deciding which light should affect this movable

Definition at line 160 of file OgreMovableObject.h.

LightTypes Ogre::Light::mLightType`[protected]`

Definition at line 518 of file OgreLight.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

MovableObject listener - only one allowed (no list) for size & performance reasons. */.

Definition at line 152 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

SceneManager holding this object (if applicable).

Definition at line 113 of file OgreMovableObject.h.

String Ogre::MovableObject::mName`[protected, inherited]`

Name of this object.

Definition at line 109 of file OgreMovableObject.h.

PlaneBoundedVolume Ogre::Light::mNearClipVolume`[mutable, protected]`

Definition at line 552 of file OgreLight.h.

bool Ogre::Light::mOwnShadowFarDist`[protected]`

Definition at line 534 of file OgreLight.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

Definition at line 116 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

node to which this object is attached

Definition at line 115 of file OgreMovableObject.h.

Vector3 Ogre::Light::mPosition`[protected]`

Definition at line 519 of file OgreLight.h.

Real Ogre::Light::mPowerScale`[protected]`

Definition at line 532 of file OgreLight.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

Flags determining whether this object is included / excluded from scene queries.

Definition at line 137 of file OgreMovableObject.h.

Real Ogre::Light::mRange`[protected]`

Definition at line 528 of file OgreLight.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

Does rendering this object disabled by listener?

Definition at line 150 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

The render queue to use when rendering this object.

Definition at line 129 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 131 of file OgreMovableObject.h.

ushort Ogre::MovableObject::mRenderQueuePriority`[protected, inherited]`

The render queue group to use when rendering this object.

Definition at line 133 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueuePrioritySet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 135 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

Static map of class name to list of animable value names.

Definition at line 242 of file OgreAnimable.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

Default query flags.

Definition at line 164 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

Default visibility flags.

Definition at line 166 of file OgreMovableObject.h.

Real Ogre::Light::mShadowFarClipDist`[protected]`

Definition at line 539 of file OgreLight.h.

Real Ogre::Light::mShadowFarDist`[protected]`

Definition at line 535 of file OgreLight.h.

Real Ogre::Light::mShadowFarDistSquared`[protected]`

Definition at line 536 of file OgreLight.h.

Real Ogre::Light::mShadowNearClipDist`[protected]`

Definition at line 538 of file OgreLight.h.

String Ogre::Light::msMovableType`[static, protected]`

Shared class-level name for Movable type.

Definition at line 550 of file OgreLight.h.

ColourValue Ogre::Light::mSpecular`[protected]`

Definition at line 521 of file OgreLight.h.

Real Ogre::Light::mSpotFalloff`[protected]`

Definition at line 527 of file OgreLight.h.

Radian Ogre::Light::mSpotInner`[protected]`

Definition at line 526 of file OgreLight.h.

Radian Ogre::Light::mSpotOuter`[protected]`

Definition at line 525 of file OgreLight.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

Definition at line 123 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

Upper distance to still render.

Definition at line 122 of file OgreMovableObject.h.

UserObjectBindings Ogre::MovableObject::mUserObjectBindings`[protected, inherited]`

User objects binding.

Definition at line 127 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

Flags determining whether this object is visible (compared to SceneManager mask).

Definition at line 139 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

Is this object visible?

Definition at line 118 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

Cached world AABB of this object.

Reimplemented in Ogre::ParticleSystem.

Definition at line 141 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

Definition at line 143 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

World space AABB of this object's dark cap.

Definition at line 145 of file OgreMovableObject.h.

Real Ogre::Light::tempSquareDist

Temp tag used for sorting.

Definition at line 76 of file OgreLight.h.

The documentation for this class was generated from the following file:

- OgreLight.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56